package jp.deadend.noname.treenote;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.EditText;

public class EditTextCursorWatcher extends EditText {
	interface Callback {
		void putValue(int val);
	}

	private Callback mCallback = null;

	public void setCallback(Callback c) {
		mCallback = c;
	}

	public EditTextCursorWatcher(Context context) {
		super(context);
	}

	public EditTextCursorWatcher(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	public EditTextCursorWatcher(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
	}

	@Override
	protected void onSelectionChanged(int selStart, int selEnd) {
		if (mCallback != null) {
			if (length() > 0) {
				mCallback.putValue(selEnd*100/length());
			} else {
				mCallback.putValue(100);
			}
		}
	}
}