package jp.deadend.noname.treenote;

import android.text.ClipboardManager;
import android.widget.EditText;

class EditTextUtils {
	private static final int DO_CUT		= 0;
	private static final int DO_COPY	= 1;
	private static final int DO_PASTE	= 2;

	private EditTextUtils() {}

	static void textCut(EditText editText, ClipboardManager cm) {
		textToFromClipboard(editText, cm, DO_CUT);
	}

	static void textCopy(EditText editText, ClipboardManager cm) {
		textToFromClipboard(editText, cm, DO_COPY);
	}

	static void textPaste(EditText editText, ClipboardManager cm) {
		textToFromClipboard(editText, cm, DO_PASTE);
	}

	private static void textToFromClipboard(EditText editText, ClipboardManager cm, int command) {
		int start = editText.getSelectionStart();
		int end = editText.getSelectionEnd();
		if (start > end) {
			int temp = start;
			start = end;
			end = temp;
		}

		if (command == DO_CUT || command == DO_COPY) {
			if (start <= end) {
				cm.setText(editText.getText().subSequence(start, end));
			} else {
				cm.setText(editText.getText().subSequence(end, start));
			}
		}
		if (command == DO_CUT || command == DO_PASTE) {
			if (start <= end) {
				editText.getText().delete(start, end);
			} else {
				editText.getText().delete(end, start);
			}
		}
		if (command == DO_PASTE) {
			editText.getText().insert(start, cm.getText());
		}
	}
}
