package jp.deadend.noname.treenote;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.EditText;
import android.view.inputmethod.InputMethodManager;
import android.view.KeyEvent;
import android.view.MotionEvent;

public class LockedEditText extends EditText {
	public LockedEditText(Context context) {
		super(context);
	}

	public LockedEditText(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	public LockedEditText(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
	}

	@Override
	public boolean onCheckIsTextEditor() {
		if (android.os.Build.VERSION.SDK_INT >= 11) {
			hideKeyboard();
			return super.onCheckIsTextEditor();
		} else {
			return false;
		}
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		if (android.os.Build.VERSION.SDK_INT >= 11) {
			hideKeyboard();
		}
		return super.onTouchEvent(event);
	}

    private void hideKeyboard(){
        InputMethodManager imm = (InputMethodManager)getContext().getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(getWindowToken(), 0);
    }

    @Override
    public boolean onKeyPreIme(int keyCode, KeyEvent event){
		if (keyCode == KeyEvent.KEYCODE_DPAD_DOWN || keyCode == KeyEvent.KEYCODE_DPAD_LEFT || keyCode == KeyEvent.KEYCODE_DPAD_RIGHT || keyCode == KeyEvent.KEYCODE_DPAD_UP || keyCode == KeyEvent.KEYCODE_SHIFT_LEFT || keyCode == KeyEvent.KEYCODE_SHIFT_RIGHT || keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_ENTER) {
			return super.onKeyPreIme(keyCode, event);
		} else {
			return true;
		}
    }
}