package jp.deadend.noname.treenote;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

class TreeNoteClipboardNode {
	private final String mSubject;
	private final String mContent;
	private final List<TreeNoteClipboardNode> children = new ArrayList<TreeNoteClipboardNode>();

	TreeNoteClipboardNode(String subject, String content) {
		mSubject = subject;
		mContent = content;
	}

	TreeNoteClipboardNode add(String subject, String content) {
		children.add(new TreeNoteClipboardNode(subject, content));

		return children.get(children.size() -1);
	}

	List<TreeNoteClipboardNode> getChildren() {
		return Collections.unmodifiableList(children);
	}

	String getSubject() {
		return mSubject;
	}

	String getContent() {
		return mContent;
	}
}