package jp.deadend.noname.treenote;

import pl.polidea.treeview.InMemoryTreeStateEditInfo;

import java.io.Serializable;

class TreeNoteEditInfo extends InMemoryTreeStateEditInfo<Integer> implements Serializable {
    private static final long serialVersionUID = 2L;

	enum TextEditType {
		SUBJECT,
		CONTENT,
		ADD_NEW,
	}

	private TextEditType textType;
	private Integer id;
	private String str;

	TreeNoteEditInfo(TextEditType t, Integer i, String s) {
		textType = t;
		id = i;
		str = s;
	}

	TextEditType getTextType() {
		return textType;
	}
	Integer getId() {
		return id;
	}
	String getString() {
		return str;
	}

	@Override
	public TreeNoteEditInfo createClone() {
		return new TreeNoteEditInfo(textType, id, str);
	}

	@Override
	public String toString() {
		switch (textType) {
		case SUBJECT:
			return "SUBJECT:"+id+","+str;
		case CONTENT:
			return "CONTENT:"+id+","+str.replace("\n", "\\n");
		case ADD_NEW:
			return "ADD_NEW:"+id+","+str;
		}

		return "UNKNOWN";
	}
}
