package jp.deadend.noname.treenote;

import android.content.Context;
import android.graphics.Canvas;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.widget.SeekBar;

public class VerticalSeekBar_Reverse extends SeekBar implements EditTextCursorWatcher.Callback {
	private OnSeekBarChangeListener myListener;

    public VerticalSeekBar_Reverse(Context context) {
        super(context);
    }

    public VerticalSeekBar_Reverse(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public VerticalSeekBar_Reverse(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }

    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
        super.onSizeChanged(h, w, oldh, oldw);
    }

    @Override
    protected synchronized void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        super.onMeasure(heightMeasureSpec, widthMeasureSpec);
        setMeasuredDimension(getMeasuredHeight(), getMeasuredWidth());
    }

	@Override
	public void setOnSeekBarChangeListener(OnSeekBarChangeListener mListener){
		this.myListener = mListener;
	}


    protected void onDraw(Canvas c) {
        c.rotate(90);
        c.translate(0, -getWidth());

        super.onDraw(c);
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (!isEnabled()) {
            return false;
        }

        switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:
		case MotionEvent.ACTION_MOVE:
		case MotionEvent.ACTION_UP:
			int i = getMax() - (int) (getMax() * event.getY() / getHeight());
			setProgress(100-i);
			switch (event.getAction()) {
			case MotionEvent.ACTION_DOWN:
				if (myListener != null) {
					myListener.onStartTrackingTouch(this);
				}
				break;
			case MotionEvent.ACTION_MOVE:
				myListener.onProgressChanged(this, 100-i, true);
				break;
			case MotionEvent.ACTION_UP:
				myListener.onStopTrackingTouch(this);
				break;
			}
			break;
		case MotionEvent.ACTION_CANCEL:
			break;
        }
        return true;
    }

	@Override
	public synchronized void setProgress(int progress) {
		super.setProgress(progress);
		onSizeChanged(getWidth(), getHeight(), 0, 0);
	}

	public void putValue(int val) {
		setProgress(val);
	}
}